<?php
class Bitfoundry_Etnpay_ProcessingController extends Mage_Core_Controller_Front_Action
{
    public function deviceTestAction() {
        $helper = Mage::helper('bitfoundryetnpay');

        if ($helper->isMobile()) {
            echo "Mobile Device";
        }
        else {
            echo "Not Mobile Device";
        }
    }

    public function redirectAction()
    {
        $etnpay = Mage::getModel('bitfoundryetnpay/pay');
        $helper = Mage::helper('bitfoundryetnpay');

        $order = $etnpay->getOrder();
        $email = ($etnpay->getOrderPlacedEmail() ? true : false);
        $order->setState(Mage_Sales_Model_Order::STATE_PENDING_PAYMENT, true);
        $order->addStatusToHistory(Mage_Sales_Model_Order::STATE_PENDING_PAYMENT,'The user was redirected to Electroneum for payment',$email);
        $order->sendNewOrderEmail();
        $order->save();

        $orderIdMd5 = md5($order->getRealOrderId() + 55);

        $fields['vendorAddress'] = $etnpay->getVendorAddress();
        $fields['amount'] = $helper->getETNAmount(Mage::app()->getStore()->getBaseCurrencyCode(), number_format($order->getGrandTotal(), 2, '.', ''));
        $fields['merchantReference'] = $order->getRealOrderId();
        $fields['currencyISOCode'] = Mage::app()->getStore()->getBaseCurrencyCode(); // ZAR

        $urlParams = "etn-it-" . $fields['vendorAddress'] ."/0" . $fields['merchantReference'] . "/" . $fields['amount'];

        ?>
        <script src="<?php echo Mage::getBaseUrl('js');?>bitfoundry/etnpay/etn.vendor-widget-0.1.0.min.js"></script>
        <div style="width:100%;">
            <h2 style="width:100%; text-align:center; color:#333; font-family:arial;"><?php echo $etnpay->getTitle();?></h2>
            <p style="width:100%; text-align:center; color:#333; font-family:arial;">You are about to pay <strong><?php echo $fields['amount'];?> ETN</strong> (<?php echo $fields['currencyISOCode'];?> <?php echo number_format($order->getGrandTotal(), 2, '.', '');?>)</p>
            <div id="electroneumQR" style="width:205px; margin:0 auto; padding:20px;">
                <div data-etn-vendor="<?php echo $urlParams;?>"></div>

                <span id="cancelLink" style="display: block; width: 100px; margin: 10px auto; text-align: center;"><a style=" text-decoration:none; color:#E2E2E2; font-size:14px;" href="/bitfoundryetnpay/processing/cancelOrder">Cancel Order</a></span>
                <span id="loadingImage" style="display: block; visibility:hidden; margin: 0 auto; text-align: center;">
                    <span id="paymentReceived" style="display:block; width:100%; visibility:hidden;">Payment Received</span>
                    <span id="confirmingPayment" style="display:block; width:100%; visibility:hidden;">Confirming Payment</span>
                    <img src="<?php echo Mage::getDesign()->getSkinUrl('images/bitfoundry/ajax-loader.gif');?>">
                </span>
                <span id="mobileInstructions" style="display:block; visibility:hidden; width:100%; margin: 10px auto; text-align: center;">
                    <p>Once payment is made, return to this page and click confirm payment below.</p>
                    <button id="paidBtn" style="background:#22B4D6; color:#FFF; padding:10px;">Payment Made</button>
                </span>
            </div>
        </div>
        <script type="text/javascript">
            const isMobile = <?php echo $helper->isMobile();?>;
            const baseUrl = '<?php echo Mage::getBaseUrl();?>';
            const merchantRef = '<?php echo $fields['merchantReference'];?>';

            if (isMobile === 0) {
                (function pollEtn() {
                  console.log('polling');
                    setTimeout(function() {
                        $.ajax({
                            url: baseUrl+'bitfoundryetnpay/processing/etnconfirmation?paymentid='+merchantRef,
                            headers: {
                                'Content-Type': 'application/x-www-form-urlencoded'
                            },
                            type: "GET",
                            success: function(data) {
                                if (data.status === 1) {
                                    document.querySelector('#loadingImage').style.cssText = "display: block; visibility:visible; margin: 0 auto; text-align: center;";
                                    document.querySelector('#paymentReceived').style.cssText = "display:block; width:100%; visibility:visible";
                                    console.table(data);
                                    setTimeout(function(){
                                        window.location.href = baseUrl+'bitfoundryetnpay/processing/success/';
                                    }, 1000); // pause before success to avoid polling too fast (confirmation poll on success page to avoid bypassing payment)
                                }
                            },
                            dataType: "json",
                            complete: pollEtn,
                            timeout: 2000
                        })
                    }, 3000);
                })();
            }
            else {
                document.querySelector('#mobileInstructions').style.cssText = "display:block; visibility:visible; width:100%; margin: 10px auto; text-align: center;";
                document.addEventListener('click', function (event) {
                    if (!event.target.matches('#paidBtn')) return;

                    event.preventDefault();

                    document.querySelector('#loadingImage').style.cssText = "display: block; visibility:visible; margin: 0 auto; text-align: center;";
                    document.querySelector('#confirmingPayment').style.cssText = "display:block; width:100%; visibility:visible";
                    (function pollEtnMobile() {
                        setTimeout(function() {
                            $.ajax({
                                url: baseUrl+'bitfoundryetnpay/processing/etnconfirmation?paymentid='+merchantRef,
                                headers: {
                                    'Content-Type': 'application/x-www-form-urlencoded'
                                },
                                type: "GET",
                                success: function(data) {
                                    if (data.status === 1) {
                                        document.querySelector('#paymentReceived').style.cssText = "display:block; width:100%; visibility:visible";
                                        document.querySelector('#confirmingPayment').style.cssText = "display:block; width:100%; visibility:hidden";
                                        document.querySelector('#mobileInstructions').style.cssText = "display:block; visibility:hidden";
                                        setTimeout(function(){
                                            window.location.href = baseUrl+'bitfoundryetnpay/processing/success/';
                                        }, 1000); // pause before success to avoid polling too fast (confirmation poll on success page to avoid bypassing payment)
                                    }
                                },
                                dataType: "json",
                                complete: pollEtnMobile,
                                timeout: 2000
                            })
                        }, 3000);
                    })();
                }, false);
            }
            /*(function pollEtn() {
                pollRepeat = setInterval(function() {
                    fetch('<?php echo Mage::getBaseUrl();?>bitfoundryetnpay/processing/etnconfirmation?paymentid=<?php echo $fields['merchantReference'];?>')
                        .then((resp) => resp.json())
                        .then(function(data){
                            if (data.status === 1) {
                                clearInterval(pollRepeat);
                                setTimeout(function(){
                                    window.location.href = '<?php echo Mage::getBaseUrl();?>bitfoundryetnpay/processing/success';
                                }, 1000); // pause before success to avoid polling too fast
                            }
                        });
                }, 5000);
            })();*/
        </script>
        <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
        <?php
    }

    private function getEtnStatus($paymentId)
    {
        // get payment confirmation from Electroneum API to confirm order
        $etnpay = Mage::getModel('bitfoundryetnpay/pay');
        $vendorAddress = $etnpay->getVendorAddress();
        $apiKey = $etnpay->getApiKey();
        $apiSecret = $etnpay->getApiSecret();
        $payload = [
            'payment_id' => '0' . $paymentId,
            'vendor_address' => 'etn-it-' . $vendorAddress
        ];

        $etnSignature = Mage::Helper('bitfoundryetnpay')->createSecuritySignature($payload, $apiSecret);


        // payment confirmation
        $etnUrl = 'https://poll.electroneum.com/vendor/check-payment';

        $ch = curl_init($etnUrl);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json',
            'ETN-SIGNATURE: ' . $etnSignature
        ]);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        curl_close($ch);

        // Decode the JSON result into an array.
        $result = json_decode($result, true);

        return $result;
    }

    public function etnconfirmationAction()
    {
        $paymentId = $this->getRequest()->getParam('paymentid');
        // get payment confirmation from Electroneum API to confirm order
        $etnpay = Mage::getModel('bitfoundryetnpay/pay');
        $vendorAddress = $etnpay->getVendorAddress();
        $apiKey = $etnpay->getApiKey();
        $apiSecret = $etnpay->getApiSecret();
        $payload = [
            'payment_id' => '0' . $paymentId,
            'vendor_address' => 'etn-it-' . $vendorAddress
        ];

        $etnSignature = Mage::Helper('bitfoundryetnpay')->createSecuritySignature($payload, $apiSecret);
        $etnUrl = 'https://poll.electroneum.com/vendor/check-payment';

        $ch = curl_init($etnUrl);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json',
            'ETN-SIGNATURE: ' . $etnSignature
        ]);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        curl_close($ch);

        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody($result);
    }

    public function successAction()
    {
        $etnpay = Mage::getModel('bitfoundryetnpay/pay');
        $order = $etnpay->getOrder();
        $paymentId = $order->getRealOrderId();

        // check status again for good measure
        $etnStatus = $this->getEtnStatus($paymentId);
        if ($etnStatus['status'] == 1) {
            // payment success
            $invoice = $order->prepareInvoice();
            $invoice->setEtnAmount($etnStatus['amount']);
            $invoice->register()->capture();

            $order->addRelatedObject($invoice);
            $email = ($etnpay->getOrderSuccessfulEmail() ? true : false);
            $order->addStatusToHistory(Mage_Sales_Model_Order::STATE_PROCESSING,'Successful payment from Electroneum confirmed.',$email);
            if ($email) {
                $etnpay->sendPaymentSuccessfulEmail($order);
            }

            $order->sendNewOrderEmail();
            $order->save();

            $invoice->sendEmail(); // send after order save otherwise Invoice Number and date don't come through on email

            $this->_redirect('checkout/onepage/success', array('_secure'=> true));
        } // end if
        else {
            die('Nice try.');
            $this->_redirect('checkout/onepage/failure', array('_secure'=> true));
            Mage::log("************************************************************************************");
            Mage::log("*    Payment Tampering");
            Mage::log("*    Looks like we have some payment redirect tampering on order: " . $order->getIncrementId() . ", key: " . $this->getRequest()->getParam('key') . ", electroneum. ELECTRONEUM STATUS CODE: ($etnConfirmationCode)");
            Mage::log("************************************************************************************");
        }
    }

    public function failureAction()
    {
        $session = Mage::getSingleton('checkout/session');
        if ($session->getLastRealOrderId())
        {
            $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
            if ($order->getId())
            {
                //Cancel order
                if ($order->getState() != Mage_Sales_Model_Order::STATE_CANCELED)
                {
                    $order->registerCancellation("Cancelled by Payment Provider")->save();
                }
                $quote = Mage::getModel('sales/quote')
                    ->load($order->getQuoteId());
                //Return quote
                if ($quote->getId())
                {
                    $quote->setIsActive(1)
                        ->setReservedOrderId(NULL)
                        ->save();
                    $session->replaceQuote($quote);
                }

                //Unset data
                $session->unsLastRealOrderId();
            }
        }

        return $this->getResponse()->setRedirect( Mage::getUrl('checkout/onepage'));
    }

    public function cancelOrderAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $etnpay = Mage::getModel('bitfoundryetnpay/pay');
        $order = $etnpay->getOrder();

        $quote = $session->getQuote();
        $quote->setIsActive(false)->save();
        $quote->delete();

        $state = $order->getState();
        if($state == Mage_Sales_Model_Order::STATE_PENDING_PAYMENT){
            $order->addStatusToHistory(Mage_Sales_Model_Order::STATE_CANCELED,'The user cancelled payment on Electronuem QR page.',false);
            $order->cancel()->save();
            Mage::getSingleton('core/session')->addNotice('Your order has been canceled.');
        }

        $this->_redirect('checkout/cart');
    }
}
